package com.loafle.overflow.central.module.infra.service;

import com.loafle.overflow.central.spring.AppConfigTest;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Port;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.discovery.Zone;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.meta.MetaCryptoType;
import com.loafle.overflow.model.meta.MetaIPType;
import com.loafle.overflow.model.meta.MetaPortType;
import com.loafle.overflow.service.central.infra.InfraService;
import com.loafle.overflow.service.central.meta.MetaCryptoTypeService;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ActiveProfiles;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@RunWith(SpringJUnit4ClassRunner.class)
@ActiveProfiles("test")
@ContextConfiguration(classes = { AppConfigTest.class })
@Ignore
public class CentralInfraServiceTest {

  @Autowired
  InfraService infraService;

  @Autowired
  CentralInfraService centralInfraService;

  @Autowired
  MetaCryptoTypeService metaCryptoTypeService;

  // probeID, List<Host>, List<Service>
  @Test
  @Ignore
  public void registDiscoverd() throws OverflowException {
    List<Host> hosts = new ArrayList<>(5);
    List<Service> services = new ArrayList<>(5);
    List<Port> ports = new ArrayList<>(5);

    Host host = null;
    Service service = null;
    Port port = null;
    MetaCryptoType cryptoType = null;

    Zone zone = new Zone();
    zone.setAddress("192.168.1.103/24");
    zone.setDiscoveredDate(new Date());
    zone.setIface("enf03");
    zone.setMac("44:8a:5b:44:8c:e4");
    zone.setMetaIPType(MetaIPType.Enum.V4.to());
    zone.setNetwork("192.168.1.0/24");

    // for (int i = 1; i < 6; i++) {
    host = new Host();
    host.setMetaIPType(MetaIPType.Enum.V4.to());
    host.getMetaIPType().setKey("V4");
    host.setAddress("192.168.1.103");
    host.setMac("44:8a:5b:44:8c:e4");
    host.setDiscoveredDate(new Date());
    host.setZone(zone);
    // for (int j = 22; j < 25; j++) {
    port = new Port();
    port.setDiscoveredDate(new Date());
    port.setHost(host);
    port.setMetaPortType(MetaPortType.Enum.TCP.to());
    port.setPortNumber(22);

    // for (int x = 24; x < 25; x++) {
    service = new Service();
    cryptoType = new MetaCryptoType();
    cryptoType.setKey("TLS");
    cryptoType.setId(Short.valueOf((short) 17));
    cryptoType.setName("TLS");

    service.setMetaCryptoType(cryptoType);
    service.setPort(port);
    service.setDiscoveredDate(new Date());
    service.setKey("SSH");
    services.add(service);
    // }
    port.setServiceList(services);
    ports.add(port);
    // }
    host.setPortList(ports);
    hosts.add(host);
    // }

    List<Infra> infras = this.centralInfraService.registDiscoverd(Long.valueOf((long) 1), hosts, services);
    System.out.println("CentralInfraServiceTest Infra List Size: " + infras.size());
  }

  @Test
  public void readAllByProbeID() {
  }

  @Test
  public void readAllByDomainID() {
  }

  @Test
  public void readAllInfraByProbeID() {
  }

  @Test
  public void registByZone() {
  }

  @Test
  public void registByHost() {
  }

  // Long probeID,
  // com.loafle.overflow.model.discovery.Service service
  @Test
  public void registByService() throws OverflowException {
    Host host = null;
    Service service = null;
    Port port = null;
    MetaCryptoType cryptoType = null;

    Zone zone = new Zone();
    zone.setAddress("192.168.1.103/24");
    zone.setDiscoveredDate(new Date());
    zone.setIface("enp3s0");
    zone.setMac("44:8a:5b:44:8c:e8");
    zone.setMetaIPType(MetaIPType.Enum.V4.to());
    zone.setNetwork("192.168.1.0/24");

    host = new Host();
    host.setMetaIPType(MetaIPType.Enum.V4.to());
    host.getMetaIPType().setKey("V4");
    host.setAddress("192.168.1.103");
    host.setMac("44:8a:5b:44:8c:e8");
    host.setDiscoveredDate(new Date());
    host.setZone(zone);

    port = new Port();
    port.setDiscoveredDate(new Date());
    port.setHost(host);
    port.setMetaPortType(MetaPortType.Enum.TCP.to());
    port.setPortNumber(22);

    service = new Service();
    cryptoType = new MetaCryptoType();
    cryptoType.setKey("TLS");
    cryptoType.setId(Short.valueOf((short) 17));
    cryptoType.setName("TLS");

    service.setMetaCryptoType(cryptoType);
    service.setPort(port);
    service.setDiscoveredDate(new Date());
    service.setKey("SSH");

    com.loafle.overflow.model.infra.InfraService in = this.infraService.registByService(Long.valueOf(3), service);

    System.out.println(in);
  }
}
